/**
 * 
 */
function onAppReady() {

	

}

$.ui.autoLaunch = false;
$.ui.backButtonText = "Back";
$.ui.useOSThemes = false;

$(document).ready(function() {

	setTimeout(function() {
		$.ui.launch();
	}, 2000);

	// setup signin and signup button events
	$("#login").on("click", function() {
		signIn();
	});

	$("#register").on("click", function() {
		signup.signUp();
	});

	$("#search").on("click", function() {
		searchOwn();
	});

	$("#callButton").click(function() {
		mobigentplugin.phoneCall($("#phone").html());
	});
	$("#save").click(function() {
		createOwnMapping();
	});

	$('.tab a').on('click', function(e) {
		e.preventDefault();
		$(this).parent().addClass('active');
		$(this).parent().siblings().removeClass('active');
		target = $(this).attr('href');
		$('.tab-content > div').not(target).hide();
		$(target).fadeIn(600);
		return false;
	});

});

var landing = {
	initApp : function() {

		var profile = getItem("userid");
		if (profile) {
			window.open("demo.html", "_self");
		} else {
			$.ui.loadContent("page1", null, null, "fade");
		}
	}
};

var signup = {

	init : function() {
		$("#waitingModal").css("display", "block");
		mobigentplugin.getCountry(
		function(result){			
			$("#country").html(result.countryName+" - "+result.country);			
			setTimeout(function() {
				$("#waitingModal").css("display", "none");
			}, 1000);
		},				
		function(err){			
			alert(JSON.stringify(err));
		});
		
	},
	signUp : function() {

		$("#ownregerror").removeClass("animate");
		appRegister();
		//window.open("demo.html","_self");

		/*registerMobigent(function(status, xhr) {
			if (status) {
				$.ui.loadContent("signin", null, null, "fade");
			} else {
				$("#ownregerror").html(
						"Own Id already exists :"
								+ xhr.responseText.split("own_")[1]);
				$("#ownregerror").addClass("animate");
				setTimeout(function() {
					$("#ownregerror").removeClass("animate");
					$("#ownregerror").html("");
				}, 3000);
			}
		});
		*/
	

	}

};

function createOwnMapping() {
	createOwnMappingMobigent(function(status) {
		if (status) {
			alert("Own Mapping Updated Successfully...");
		} else {
			alert("Failed to update Own Mapping");
		}
	});
}

function signIn() {
	$("#login").removeClass("animate");
	loginMobigent(function(status) {
		if (status) {
			$.ui.loadContent("main", null, null, "fade");
		} else {
			$("#ownloginerror").html("Login failed. Try again with right data");
			$("#ownloginerror").addClass("animate");
			setTimeout(function() {
				$("#ownloginerror").removeClass("animate");
				$("#ownloginerror").html("");
			}, 3000);
		}
	});
	// $.ui.loadContent("main", null, null, "fade");
}

function startApp() {
	$.ui.clearHistory();
}

function profile() {
	var profile = JSON.parse((($.ui.profileInfo)[0]).data);
	$("#phone").html(profile.phone);
}

function lookupMobigent(callBack) {
	$.ui.lastSearch = $("#searchtext").val();
	var object = new Object();
	var filterData = "datadomain = 'Ownmappings' and data->>'ownId'='{0}'";
	filterData = String.format(filterData, $("#searchtext").val());
	var object = 'data={"objectClass":"com.jdo.CloudRowData",action="list",limit=1,offset=0,jsonFilter:"'
			+ filterData + '"}';
	execCommand(object, function(data) {
		var respJ = JSON.parse(data);
		if (respJ.rows) {
			respJ = respJ.rows;
		}
		if (respJ.length > 0) {
			$.ui.profileInfo = respJ;
			callBack(true, respJ);
		} else {
			callBack(false, respJ);
		}
	});
}

function getMobigentMappings(ownId, callBack) {
	var object = new Object();
	var filterData = "datadomain = 'Ownmappings' and data->>'ownId'='{0}'";
	filterData = String.format(filterData, ownId);
	var object = 'data={"objectClass":"com.jdo.CloudRowData",action="list",limit=1,offset=0,jsonFilter:"'
			+ filterData + '"}';
	execCommand(object, function(data) {
		var respJ = JSON.parse(data);
		if (respJ.rows) {
			respJ = respJ.rows;
		}
		if (respJ.length > 0) {
			callBack(true, respJ);
		} else {
			callBack(false, respJ);
		}
	});
}

function registerMobigent(callBack) {
	// data={"objectClass":"com.jdo.CloudRowData",action="list",limit=10,offset=0,jsonFilter:"datadomain%20=%20%27Users%27%20and%20data->>%27user%27=%27dhaneesh%27"}
	// http://localhost:8080/buzzoo/micromodel?data={%22objectClass%22:%22com.jdo.CloudRowData%22,action=%22list%22,limit=10,offset=0
	var object = new Object();
	var filterData = "datadomain = 'Ownusers' and data->>'ownId'='{0}'";
	filterData = String.format(filterData, $("#searchtext").val());
	// http://localhost:8080/buzzoo/micromodel?data={"objectClass":"com.jdo.CloudRowData",limit=1,offset=0,action="add_or_edit",object:{dataDomain="Ownmappings",dataKey:"dhaneesh",data:"{\"ownId\":\"dhaneesh\",\"phone\":\"98817663210\"}"}}
	var model = {
		ownId : $("#rusername").val(),
		password : $("#rpassword").val()
	};
	var object = createObject("Ownusers", "own_" + $("#rusername").val(), model);
	execCommand(object, function(data) {
		try {
			var respJ = JSON.parse(data);
			if (respJ && respJ.dataKey == "own_" + $("#rusername").val()) {
				callBack(true);
			} else {
				callBack(false);
			}
		} catch (e) {
			callBack(false, data);
		}
	});
}
function getOwnId() {
	var profile = getItem("profile");
	if (profile) {
		prof = JSON.parse(profile);
		return prof.ownId;
	} else {
		return null;
	}
}

function loadLocalProfile() {
	var ownId = getOwnId();
	$("#localOwnId").html(ownId);
	var mapping = getItem("ownmapping");
	if (mapping) {
		mapping = JSON.parse(mapping);
		setMappingToUI(mapping);
	} else {
		if (ownId) {
			getMobigentMappings(ownId, function(status, rows) {
				if (status) {
					setItem("ownmapping", JSON.stringify(rows));
					setMappingToUI(rows);
				}
			});
		}
	}
}
function setMappingToUI(rows) {
	$("#ownmapping").val((JSON.parse(rows[0].data)).phone);
}
function createOwnMappingMobigent(callBack) {
	var ownId = getOwnId();
	var model = {
		ownId : ownId,
		phone : $("#ownmapping").val()
	};
	var mapping = getItem("ownmapping");
	var uuid = guid();
	if (mapping) {
		mapping = JSON.parse(mapping);
		if (mapping.length) {
			uuid = mapping[0].dataKey;
		} else {
			uuid = mapping.dataKey;
		}
	}
	var object = editObject("Ownmappings", uuid, model);
	execCommand(object, function(data) {
		try {
			var respJ = JSON.parse(data);
			if (respJ && respJ.dataKey == uuid) {
				getMobigentMappings(ownId, function(status, rows) {
					if (status) {
						setItem("ownmapping", JSON.stringify(rows));
						callBack(true);
					} else {
						callBack(false);
					}
				});
			} else {
				callBack(false);
			}
		} catch (e) {
			callBack(false, data);
		}
	});
}
function loginMobigent(callBack) {
	var object = new Object();
	var filterData = "datadomain = 'Ownusers' and data->>'ownId'='{0}' and data->>'password'='{1}'";
	filterData = String.format(filterData, $("#username").val(), $("#password")
			.val());
	var object = 'data={"objectClass":"com.jdo.CloudRowData",action="list",limit=1,offset=0,jsonFilter:"'
			+ filterData + '"}';
	execCommand(object, function(data) {
		var respJ = JSON.parse(data);
		if (respJ.rows) {
			respJ = respJ.rows;
		}
		if (respJ.length > 0) {
			var profile = (respJ[0]).data;
			setItem("profile", profile);
			callBack(true);
		} else {
			callBack(false);
		}

	});
}

function execCommand(data, callBack) {
	$.ajax({
		type : "POST",
		url : window.serverRoot,
		data : data,
		success : function(data, status) {
			callBack(data);
		},
		error : function(xhr, error) {
			console.debug(xhr.responseText);
			console.debug(error);
			callBack(xhr);
		},
		async : true
	});
}
