
(function($) {
	$.fn.progressBlock = function(info) {	
		$("#waitingModal").remove();
		var html='<div id="waitingModal" class="apploader" style="display:block;position: absolute; z-index: 1000; '+
		'width: 100%; text-align: center; height: 100%; background: black; color: white; opacity: 0.8; margin: auto;top:0px">'+
		'<div style="margin: 0px auto; vertical-align: ce; margin-top: 40%; color: white; font-size: 1.6em; font-weight: 500;">'+info+'</div>'+			
		'<div style="position:relative;margin-top:20px;display: block" id="spinnerProgress"		class="sk-spinner sk-spinner-three-bounce">'+
		'<div class="sk-bounce1"></div>	<div class="sk-bounce2"></div>		<div class="sk-bounce3"></div>	</div>	</div>';
		var di = (this)[0]; 
		$(di).append(html);
		di.dispose =function(cb){
			setTimeout(function(){
				$("#waitingModal").remove();
				if(cb){
					cb();
				}
			},500);
			
		};
		return di;
	},	
	$.fn.pushMenu = function(options) {
		var dia = (this);		
		for(var a=0;a<dia.length;a++){
			var di = dia[a];			
			var transition =$(di).attr("data-transition");
			var viewId =$(di).attr("data-view");
			var menuView = document.getElementById(viewId);
			var selectedId = $(di).attr("data-out");
			di.viewElement =menuView;
			di.selectedId = selectedId;
			$("#"+viewId+" .close").unbind();
			if(transition){			
				$(di).click(function() {
					classie.toggle(this, 'active');
					classie.toggle(this.viewElement, 'cbp-spmenu-open');
					$(".searchtext").removeAttr("readonly");
					$("#"+viewId+" .close").unbind();
					$("#"+viewId+" .close").click(function(){					
						classie.toggle(di.viewElement, 'cbp-spmenu-open');
					});
					this.dataLoaded=false;
					var topObj = this;
					
					this.onSelected=function(parent,value){
						if(parent.selectedId){
							$("#"+parent.selectedId).val(value);
						}	
						classie.toggle(parent.viewElement, 'cbp-spmenu-open');
					};
					if(!this.dataLoaded){		
						args = 'obj';
						body = 'return '+$(this.viewElement).attr("data-load")+'(obj);';
						myFunc = new Function(args, body);
						
						//var tmpFunc = new Function(+"(topObj)");						
						myFunc(topObj);
						this.dataLoaded=true;
					}
				});
			}
		}
		
	},
    $.fn.dataView = function() {    	
    	var di = (this)[0]; 
    	var keys  =$(di).attr("data-keys");
    	var values =$(di).attr("data-values");
    	var domain  =$(di).attr("data-domain");
    	var method =$(di).attr("data-method"); 
    	var view =$(di).attr("data-view"); 
    	
    	var data=null;
    	if(method=="POST"){
    		data ="datadomain = '"+domain+"' ";
    		if(keys){
    			keys = keys.split(",");
    			values =  values.split(",");
        		var app=" and ";
        		$(keys).each(function(a,b){
        			data+=app+"data ->>'"+b+"' = '"+values[a]+"'";
        		});
        	}
    		data = 'data={"objectClass":"com.jdo.CloudRowData",action="list",limit=1,offset=0,jsonFilter:"'
    			+ data + '"}';
    	}
    	execCommand($(di).attr("data-url"),$(di).attr("data-method"),data,function(data){
    		processResult(JSON.parse(data),view);
    	});
    	return di;
    }   
    function execCommand(url,method,data,callBack) {	
    	$("#spinnerProgress").css("display","block");
    	$(".modal-body").empty();
    	createModal();
		$.ajax({
			type : method,
			url : url,
			data : data,
			success : function(data, status) {
				$("#spinnerProgress").css("display","none");
				callBack(data);
			},
			error:function(xhr,response){
				$("#spinnerProgress").css("display","none");
				error({error:"Network error"});
			},
			async : true
	});
    }
	function processResult(data,view){
		if(view=="form"){
			var object=data.rows[0];
			createWindow(object);
		}else{
			
		}				
	}
	
	function error(data){
		createWindow(data);
	}
	
	function createModal(){
		
		$modal = $('.modal-frame');
	    $overlay = $('.modal-overlay');
	    $modal.bind('webkitAnimationEnd oanimationend msAnimationEnd animationend', function (e) {
	        if ($modal.hasClass('state-leave')) {
	            $modal.removeClass('state-leave');
	        }
	    });
	    $('.close').on('click', function () {
	        $overlay.removeClass('state-show');
	        $modal.removeClass('state-appear').addClass('state-leave');
	    });
	    $('.open').on('click', function () {
	        $overlay.addClass('state-show');
	        $modal.removeClass('state-leave').addClass('state-appear');
	    });
	    $overlay.addClass('state-show');
        $modal.removeClass('state-leave').addClass('state-appear');
	}
	
	function createWindow(object){		

	    var html="";
	    if(!object.error){
		    var dataObj = JSON.parse(object.data);
		   // $(".modal-body").append("<ul>");
		    html='<ul><li><h2>Profile</h2></li>';
		    for(var k in dataObj){
		    	html+='<li><p>'+k+'</p><p>'+dataObj[k]+'</p></li>';
		    }
		    html+='</ul>';
	    }else{
	    	html="<div>"+object.error+"</div>"
	    	
	    }
	    $(".modal-body").append(html);
	    
	    
	}
//	function pushMenu() {
		
//		this.menuLeft = document.getElementById('cbp-spmenu-s1'), 
//		this.menuRight = document.getElementById('cbp-spmenu-s2'), 
//		this.menuTop = document.getElementById('cbp-spmenu-s3'),
//		this.menuBottom = document.getElementById('cbp-spmenu-s4'),
//		this.showLeft = document.getElementById('showLeft'), 
//		this.showRight = document.getElementById('showRight'),
//		this.showTop = document.getElementById('showTop'),
//		this.showBottom = document.getElementById('showBottom'), 
//		this.showLeftPush = document.getElementById('showLeftPush'), 
//		this.showRightPush = document.getElementById('showRightPush'),
//		this.body = document.body;
//		
//		if (showLeft) {
//			showLeft.onclick = function() {
//				classie.toggle(this, 'active');
//				classie.toggle(menuLeft, 'cbp-spmenu-open');
//				disableOther('showLeft');
//			};
//			showRight.onclick = function() {
//				classie.toggle(this, 'active');
//				classie.toggle(menuRight, 'cbp-spmenu-open');
//				disableOther('showRight');
//			};
//			showTop.onclick = function() {
//				classie.toggle(this, 'active');
//				classie.toggle(menuTop, 'cbp-spmenu-open');
//				disableOther('showTop');
//			};
//			showBottom.onclick = function() {
//				classie.toggle(this, 'active');
//				classie.toggle(menuBottom, 'cbp-spmenu-open');
//				disableOther('showBottom');
//			};
//			showLeftPush.onclick = function() {
//				classie.toggle(this, 'active');
//				classie.toggle(body, 'cbp-spmenu-push-toright');
//				classie.toggle(menuLeft, 'cbp-spmenu-open');
//				disableOther('showLeftPush');
//			};
//			showRightPush.onclick = function() {
//				classie.toggle(this, 'active');
//				classie.toggle(body, 'cbp-spmenu-push-toleft');
//				classie.toggle(menuRight, 'cbp-spmenu-open');
//				disableOther('showRightPush');
//			};
//		}
//
//	}

//	function disableOther(button) {
//		if (button !== 'showLeft') {
//			classie.toggle(showLeft, 'disabled');
//		}
//		if (button !== 'showRight') {
//			classie.toggle(showRight, 'disabled');
//		}
//		if (button !== 'showTop') {
//			classie.toggle(showTop, 'disabled');
//		}
//		if (button !== 'showBottom') {
//			classie.toggle(showBottom, 'disabled');
//		}
//		if (button !== 'showLeftPush') {
//			classie.toggle(showLeftPush, 'disabled');
//		}
//		if (button !== 'showRightPush') {
//			classie.toggle(showRightPush, 'disabled');
//		}
//	}

}(jQuery));