var mobigentplugin = {   
    getServerProfile: function() {
    	
    },    
    getStats :function(callback){  
    	try{
    		this.execute("stats",[], callback);
    	}catch(e){
    		callback({"total":"100","unread":"35"});
    	}
    },    
    startAgent :function(user,callback){     	
    	this.execute("start",[user], callback);
    },	
	phoneCall :function(callerId,callback){     	
    	this.execute("call",[callerId], callback);
    },   
    getCountry:function(callBack,onErrorCallBack){
    	this.execute("getCountry", [ "countrycode" ],callBack,onErrorCallBack);
    },
    mobileRegister:function(args,callBack,onErrorCallBack){
    	this.execute("mregister",args,callBack,onErrorCallBack);
    },
    fetchSettings:function(callBack,onErrorCallBack){
    	this.execute("fetchSettings",["myphone"],callBack,onErrorCallBack);
    },
    updateSettings:function(args,callBack,onErrorCallBack){
    	this.execute("updateSettings",args,callBack,onErrorCallBack);
    },  
    clearDiverts:function(callBack,onErrorCallBack){
    	this.execute("clearDiverts",["myphone"],callBack,onErrorCallBack);
    },
    fetchDiverts:function(callBack,onErrorCallBack){
    	this.execute("fetchDiverts", [ "fetchDiverts" ],callBack,onErrorCallBack);
    },
    callLogs:function(callBack,onErrorCallBack){
    	this.execute("callLogs",[ "myphone"],callBack,onErrorCallBack);
    },    
    event:function(args,callBack,onErrorCallBack){
    	this.execute("event",args,callBack,onErrorCallBack);
    },  
    createTask:function(args,callBack,onErrorCallBack){
    	this.execute("createTask",args,callBack,onErrorCallBack);
    },  
    putpref:function(args,callBack,onErrorCallBack){
    	this.execute("putpref",args,callBack,onErrorCallBack);
    },  
    pushContacts:function(args,callBack,onErrorCallBack){
    	this.execute("pushContacts",args,callBack,onErrorCallBack);
    },  
    refreshContacts:function(args,callBack,onErrorCallBack){
    	this.execute("refresh",[ "refresh" ],callBack,onErrorCallBack);
    },  
    divertSession:function(callBack,onErrorCallBack){
    	this.execute("divertSession",[ "myphone" ],callBack,onErrorCallBack);
    },  
    dcall:function(args,callBack,onErrorCallBack){
    	this.execute("dcall",args,callBack,onErrorCallBack);
    },  
    
    execute:function(name,argArray,callback,onErrorCallBack){
    	cordova.exec(function(winParam) {
    		callback(winParam);
		}, function(error) {
			if(onErrorCallBack){
				onErrorCallBack(error);
			}else{
				alert("Changed Data......."+error);	
			}			
		}, "Mobigent",
		name,argArray);
    }
};
if (!isMobile.any()) {
	if(typeof cordova=="undefined"){
		cordova=new Object();
		cordova.exec=function(fn1){
			fn1(new Object());
		};
	}
}