var isMobile = {
    Android: function() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function() {
        return navigator.userAgent.match(/IEMobile/i);
    },
    any: function() {
        return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
    }
};
var toast=function(msg,imgS){
	var imgSr="";
	if(imgS){
		 imgSr ="<img style=\"padding:10px;max-width:85%\" src=\""+imgS+"\"/>";
	}
	var width=($(window).width())*.8;
	var left=($(window).width())*.1;

	$("<div class='ui-loader ui-overlay-shadow ui-body-a ui-corner-all'>"+imgSr+"<h2 style=\"width:100%;font-size:16px;text-align:center\">"+msg+"</h2></div>")
	.css({ display: "block",
		opacity: 0.90,
		position: "fixed",
		padding: "7px",
		"text-align": "center",
		width: width+"px",
		left: left,
		top: $(window).height()/3 })
	.appendTo(".page").delay( 2500 )
	.fadeOut( 500, function(){
		$(this).remove();
	});
}
String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};


function showAlert(data,title,buttonName) {
       /*navigator.notification.alert(
            data,  // message
            alertDismissed,         // callback
            title,            // title
            buttonName                  // buttonName
        );*/
        alert(data);
}

function alertDismissed(){
	
}

function registerEvents(id) {
	
	$("#status").click(
			function() {
				var serObj = $("#status");
				var attr =$("#status").html();			
				toggleServiceStatus(serObj,attr);
				
			});	
	$("#tenantInfo li").click(function(){
		if($(this).attr("link") && $(this).attr("link")!="")
			window.open($(this).attr("link"),"_self");
		
		return false;
	});	
}

function toggleServiceStatus(serObj,attr){
	if (attr == "on") {
		setServiceStatus(serObj,"off");
		onPreference("status","off","Service Deactivated");
	} else {
		setServiceStatus(serObj,"on");
		onPreference("status","on","Service Activated");
	}
}
function setServiceStatus(serObj,attr){
	if (attr == "on") {
		serObj.css("background", "#5cb85c");
		serObj.html("on");
	} else {
		serObj.css("background", "#f66");
		serObj.html("off");
		
	}
}
function onPreference(key,value,message) {
	mobigentplugin.putpref([ key, value,message ],
	function(){		
		
	},function(err){
		showAlert(err);		
	});
}

function getCountyCode(){
	
}
function initSettings(result){	
	//server=result.server;
	if(result.divertAddress !=""){
		$("#divertinfo").css("display","block");
		$("#divertinfo #phone").html(result.divertAddress);
	}		
	user=result.myphone;
	var serObj = $("#status");		
	if(result.status=="")
		result.status="on";		
	setServiceStatus(serObj,result.status);			
	$("#span1").html(user);
}

function divert(from,type,number){	
	window.open("divert.html#"+from+"#"+type+"#"+number,"_self");
}

function syncContacts(callBack){
	var options = new ContactFindOptions();
	options.filter = "";
	options.multiple = true;
	var filter = [ "displayName", "phoneNumbers", "photos" ];
	navigator.contacts.find(filter,
		function onContacts(contacts){
			displayContact(contacts,callBack);
		},function(){}, 
	options);
}

function displayContact(contacts,callBack) {	
	var myContacts = new Object();
	var myContactsA = new Array();
	var defaultImagePath = "user.png";
	
	var phMap=[];
	
	for (var i = 0; i < contacts.length; i++) {
		if (contacts[i].phoneNumbers == null)
			continue;
		var img = contacts[i].photos != null ? contacts[i].photos[0].value
				: defaultImagePath;
		if (contacts[i].phoneNumbers.length)
			for (var j = 0; j < contacts[i].phoneNumbers.length; j++) {
				var pNumber = contacts[i].phoneNumbers[j].value;
				var name = contacts[i].displayName != null ? contacts[i].displayName
						: "No name";
				
				if(phMap[pNumber])
					continue;
				
				phMap[pNumber]=true;

				// To sort the names based on the starting letter  
				// Stores the names in that array 
				var index = name.substring(0, 1).toUpperCase();

				if (typeof myContacts[index] == 'undefined') {
					myContacts[index] = new Array();
				}

				// cuts the large names 
				if (name.length > 35) {
					name = name.substr(0, 35) + "...";
				}
				// Push every details into an array. 
				myContacts[index].push({
					"name" : name,
					"pNumber" : pNumber,
					"img" : img
				});
				myContactsA.push({
					"name" : name,
					"phone" : pNumber,
					"photo" : img
				});

			}

	}
	deleteWithCondition("contacts","",function(){
		minsert("contacts", myContactsA, function() {
			pushContacts(myContactsA,callBack);
		});	
	});
	
}
function pushContacts(contactList,callBack) {
	//console.log("Contacts List $$$$$$$$$$$ ::::::::::: "+contactList.length);
	var ca = new Array();
	for (var i = 0; i < contactList.length; i++) {
		var co = new Object();
		co.contact1 = user;
		co.pkey = i;
		co.contact2 = contactList[i].phone;
		co.linktype = "1";
		co.contact2name=contactList[i].name;
		if(co.contact2name){
			co.contact2name = co.contact2name.replace(/(\r\n|\n|\r)/gm,"");
			
			co.contact2name = co.contact2name.replace(/[&]/gm,"");
		}
		ca.push(co);
		console.log("Contact Fetched:::: "+contactList[i].phone+ " Contact 1->"+user);
	}
	
	//
	var co = new Object();
	co.contact1 = user;
	co.pkey = contactList.length;
	co.contact2 = user;
	co.linktype = "1";
	co.contact2name=user;
	ca.push(co);
	//
	
	var dmMeta = new Object();
	dmMeta.objectClass = "com.jdo.ContactMaps";
	dmMeta.objects = ca;
	
	dmMeta.action = "add_or_edit";
	
	mobigentplugin.pushContacts([dmMeta,
	                   			"SERVER_URL", "data", "imageName"],
	                   			function(result) {	
	                   				console.log("Returned Back from Contacts Sync");
	                   				if(callBack){
	                   					callBack(contactList);
	                   				}
	                   			}, function(err) {
	                   				showAlert(err);
	                   			});
}
function getNumbersFromString(str){
	var numstr="";
	for(var i=0;i<str.length;i++){				
		var firstChar = str.charAt(i);
		if( firstChar <='9' && firstChar >='0') {
			numstr+=firstChar; 
		}
	}
	return numstr;
}
function registerOpenWindow(){
//	if(cordova){
//		window.open=function(a,b){
//			
//			cordova.exec(function(result) {			
//			}, function(err) {
//				showAlert(err);
//			}, "ContactsPlugin", "window", [a]);
//			
//			console.log("Device Ready.......open called")
//		};
//	}

}
function adjustContentView(){	
	var fHeight = $(".footer").height();
	$(".content").css("min-height",($(window).height()-(fHeight+$(".appHeader").height()+1))+"px");
	$(".content").css("margin-bottom",fHeight+"px");
}