var divertNumber = null;
var offset = 0;
var fc = 50;
var contacts = null;
var server = "SERVER_URL";
function refreshContacts() {
	mobigentplugin.refresh(function(result) {
		renderContacts(contacts);
		toast("Data Refreshed Successfully");
	}, function(err) {
		showAlert(err);
	});
}

var user = null;
var type = null;
var dMap = [];

function onAppReady() {
	registerEvents();
	adjustContentView();
	initDatabase(function() {

		user = getItem['userid'];

		type = $.trim(window.location.href.split("#")[1]);
		type = type.replace("hhhh", "/");
		$("#header").html(user);
		$("#span1").html(user);

		mobigentplugin.fetchSettings(function(dm) {
			if (!dm.status || dm.status == "") {
				dm.status = "on";
			}
			initSettings(dm);

			fetchContacts();

		}, function(err) {

			showAlert(err);
		});

	});

}

function fetchContacts() {
	readRecords("contacts", "", function(crecs) {
		if (!crecs || crecs.length == 0) {
			console.log("Reading contacts from Mobile");
			syncContacts(function(myContactsA) {
				renderContacts(myContactsA);
			});
		} else {
			//showAlert("LocalData","Local","Done");
			renderContacts(crecs);
		}
	});

}
function onContactError() {
	console.log("Error");
}

function renderContacts(contacts1) {

	$("#contacts li").remove();
	$("#contacts li").unbind();
	contacts = contacts1.sort(sortNames);

	if (isMobile.any()) {
		
		mobigentplugin.fetchDiverts(function(result) {
			dMap = [];
			$.each(result, function(i, j) {
				dMap[j.number] = j;
			});
			processData(dMap);
		}, function(err) {
			showAlert(err);
		});
	} else {

		processData(dMap);
	}

}

function isDiverted(phone) {
	var ppp = getNumbersFromString(phone);
	var len = Math.min(10, ppp);
	var ph = ppp.substring(ppp.length - len, ppp.length);
	return dMap[ph];
}
function processData(dMap) {
	var cs = contacts.length;
	var dataS = "";
	for (i = offset; i < cs + offset; i++) {
		//	for (i = 0; i < 10; i++) {
		var record = contacts[i];
		var ha = '</h2>';

		if (isDiverted(record.phone)) {
			ha = '<img class="pin" src="images/reachy/r_arr_1.png"/></h2>';
		}
		dataS += '<li>' //+ '<img class="photo"	src="' + record.photo + '" />'
				+ '<div style="display:inline-block"><h2 class="small name">'
				+ record.name + ha + '<p class="small smalltext phone">'
				+ record.phone + '</p></div>'
				//+'</a> <a onclick="openConfigure(this);" class="cdn">Divert Call</a></li>';
				//+ '<img class="callbutton"  style="float:right;position:absolute;margin-top:5px;right:2px;height:50px;border-radius:30px;border:1px solid #fff" src="call.jpg"/><img class="configure"  style="float:right;position:absolute;margin-top:5px;right:50px;height:50px;border-radius:30px;border:1px solid #fff" src="rsettings.png"/>';
				+ '</li>';
	}
	$("#contacts").append(dataS);

	$("#contacts li .callbutton").click(function(event) {
		event.stopPropagation();
		callTarget($(this).parent());
	});

	$("#contacts li .configure").click(function(event) {
		event.stopPropagation();
		openConfigureParent($(this).parent());
	});

	//offset += fc;
	//$("#contacts").listview('refresh');
}
function sortNames(a, b) {
	return a.name.toLowerCase() > b.name.toLowerCase() ? 1 : -1;
}
function getUser() {
	return user;
}

function goBack() {
	window.open("demo.html", "_self");
}

$(document).ready(function() {

	if (!isMobile.any()) {

		onAppReady();
		var myContactsA = new Array();
		myContactsA.push({
			"name" : "Dhan",
			"phone" : "Dhan",
			"photo" : "arr.png"
		});
		myContactsA.push({
			"name" : "Dhan1",
			"phone" : "Dhan1",
			"photo" : "user.png"
		});

		renderContacts(myContactsA);

	}

});

function callTarget(obj) {

	var phone = $(".phone", $(obj)).html();

	cordova.exec(function(result) {

	}, function(err) {
		showAlert(err);
	}, "ContactsPlugin", "call", [ phone ]);

	return false;
}
